## mathicgb 1.0~git20220621

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(mathicgb VERSION 1.0 LANGUAGES CXX)

option(enable_mgb "Build mgb" ON)
option(with_tbb "use TBB for multithreading" auto)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

find_package(Threads 2.1 REQUIRED QUIET)
find_package(Memtailor   REQUIRED)
find_package(Mathic      REQUIRED)
if(with_tbb)
  find_package(TBB       REQUIRED)
elseif(with_tbb STREQUAL auto)
  find_package(TBB)
  set(with_tbb ${TBB_FOUND})
endif()

add_library(memtailor STATIC IMPORTED)
set_target_properties(memtailor PROPERTIES
  IMPORTED_LOCATION             "${MEMTAILOR_LIBRARIES}"
  INTERFACE_INCLUDE_DIRECTORIES "${MEMTAILOR_INCLUDE_DIR}")

add_library(mathic STATIC IMPORTED)
set_target_properties(mathic PROPERTIES
  IMPORTED_LOCATION             "${MATHIC_LIBRARIES}"
  INTERFACE_INCLUDE_DIRECTORIES "${MATHIC_INCLUDE_DIR}")

add_compile_options(
  -DHAVE_CXX11=1
  -DPACKAGE_NAME="${PROJECT_NAME}"
  -DPACKAGE_TARNAME="${PROJECT_NAME}"
  -DPACKAGE_VERSION="${PROJECT_VERSION}"
  -DPACKAGE_STRING="${PROJECT_NAME} ${PROJECT_VERSION}"
  -DPACKAGE_BUGREPORT=""
  -DPACKAGE_URL=""
  -DPACKAGE="${PROJECT_NAME}"
  $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
  -Wall -Wextra -Wno-unused-parameter -Wno-unused-value -Wno-unused-variable -Wno-sign-compare
  )

add_subdirectory(src)

set_target_properties(mathicgb PROPERTIES PUBLIC_HEADER src/mathicgb.h)

install(TARGETS mathicgb LIBRARY DESTINATION lib)
install(DIRECTORY src/mathicgb
  DESTINATION include
  FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h"
  )
install(FILES doc/mgb.1 TYPE MAN)
install(FILES README.md gpl-2.0.txt gpl-3.0.txt
  DESTINATION licenses/mathicgb
  )

if(enable_mgb)
  add_executable(mgb
    src/cli/GBMain.cpp
    src/cli/CommonParams.hpp   src/cli/CommonParams.cpp
    src/cli/GBAction.hpp       src/cli/GBAction.cpp
    src/cli/GBCommonParams.hpp src/cli/GBCommonParams.cpp
    src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp
    src/cli/SigGBAction.hpp    src/cli/SigGBAction.cpp
    src/cli/HelpAction.hpp     src/cli/HelpAction.cpp
    )
  target_link_libraries(mgb mathicgb)
  install(TARGETS mgb RUNTIME DESTINATION bin)
endif()

=== debian/changelog ===
mathicgb (1.0~git20220621-2) unstable; urgency=medium

  * debian/patches/libatomic.patch
    - Restore patch; the build was still failing on mipsel and m68k
      linking with TBB without the -latomic flag.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 25 Jun 2022 22:11:22 -0400

mathicgb (1.0~git20220621-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/patches/big-endian.patch
    - Remove patch; issue fixed upstream.
  * debian/patches/libatomic.patch
    - Remove patch; the issue was fixed in a recent upload of the TBB
      package (2021.5.0-11).

 -- Doug Torrance <dtorrance@debian.org>  Wed, 22 Jun 2022 22:56:03 -0400

=== debian/control ===
Source: mathicgb
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgtest-dev <!nocheck>,
               libmathic-dev,
               libmemtailor-dev,
               libtbb-dev [linux-any],
               pkg-config
Standards-Version: 4.6.1
Section: math
Homepage: https://github.com/Macaulay2/mathicgb
Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git
Vcs-Browser: https://salsa.debian.org/math-team/mathicgb
Rules-Requires-Root: no

Package: mathicgb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Compute Groebner bases (command line tool)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the command line tool.

Package: libmathicgb-dev
Section: libdevel
Architecture: any
Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Compute Groebner bases (developer tools)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the developer tools.

Package: libmathicgb0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Compute Groebner bases (runtime library)
 Mathicgb is a program for computing Groebner basis and signature Groebner
 bases.  Mathicgb is based on the fast data structures from mathic.
 .
 The paper "Practical Groebner Basis Computation" describes the algorithms in
 Mathicgb from a high level. It was presented at ISSAC 2012 and is available at
 http://arxiv.org/abs/1206.6940
 .
 This package contains the runtime library.

## mathicgb 1.0~git20231121

=== debian/changelog ===
mathicgb (1.0~git20231121-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.6.2.
  * debian/copyright
    - Update my copyright years.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 21 Dec 2023 08:58:50 -0500

## mathicgb 1.0~git20240206

=== src/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  add_compile_options(-DMATHICGB_DEBUG -DMATHIC_DEBUG -DMEMT_DEBUG)
endif()

add_library(mathicgb STATIC
  mathicgb.h
  mathicgb.cpp
  mathicgb/MonoArena.hpp
  mathicgb/Range.hpp
  mathicgb/mtbb.hpp
  mathicgb/PrimeField.hpp
  mathicgb/MonoMonoid.hpp
  mathicgb/MonoProcessor.hpp
  mathicgb/MonoOrder.hpp
  mathicgb/Unchar.hpp
  mathicgb/MathicIO.hpp
  mathicgb/NonCopyable.hpp
  mathicgb/StaticMonoMap.hpp
  mathicgb/KoszulQueue.hpp
  mathicgb/Poly.hpp
  mathicgb/ReducerHelper.hpp
  mathicgb/MonomialMap.hpp
  mathicgb/RawVector.hpp
  mathicgb/Atomic.hpp
  mathicgb/ScopeExit.hpp
  mathicgb/FixedSizeMonomialMap.h # change name?
  mathicgb/ReducerPack.hpp        mathicgb/ReducerPack.cpp
  mathicgb/ClassicGBAlg.hpp       mathicgb/ClassicGBAlg.cpp
  mathicgb/MonoLookup.hpp         mathicgb/MonoLookup.cpp
  mathicgb/SigPolyBasis.hpp       mathicgb/SigPolyBasis.cpp
  mathicgb/Basis.hpp              mathicgb/Basis.cpp
  mathicgb/ModuleMonoSet.hpp      mathicgb/ModuleMonoSet.cpp
  mathicgb/PolyBasis.hpp          mathicgb/PolyBasis.cpp
  mathicgb/PolyHashTable.hpp      mathicgb/PolyHashTable.cpp
  mathicgb/PolyRing.hpp           mathicgb/PolyRing.cpp
  mathicgb/Reducer.hpp            mathicgb/Reducer.cpp
  mathicgb/ReducerDedup.hpp       mathicgb/ReducerDedup.cpp
  mathicgb/ReducerHash.hpp        mathicgb/ReducerHash.cpp
  mathicgb/ReducerHashPack.hpp    mathicgb/ReducerHashPack.cpp
  mathicgb/ReducerNoDedup.hpp     mathicgb/ReducerNoDedup.cpp
  mathicgb/ReducerPackDedup.hpp   mathicgb/ReducerPackDedup.cpp
  mathicgb/SignatureGB.hpp        mathicgb/SignatureGB.cpp
  mathicgb/SigSPairs.hpp          mathicgb/SigSPairs.cpp
  mathicgb/SPairs.hpp             mathicgb/SPairs.cpp
  mathicgb/SigSPairQueue.hpp      mathicgb/SigSPairQueue.cpp
  mathicgb/SparseMatrix.hpp       mathicgb/SparseMatrix.cpp
  mathicgb/QuadMatrixBuilder.hpp  mathicgb/QuadMatrixBuilder.cpp
  mathicgb/TypicalReducer.hpp     mathicgb/TypicalReducer.cpp
  mathicgb/F4Reducer.hpp          mathicgb/F4Reducer.cpp
  mathicgb/F4MatrixBuilder.hpp    mathicgb/F4MatrixBuilder.cpp
  mathicgb/QuadMatrix.hpp         mathicgb/QuadMatrix.cpp
  mathicgb/F4MatrixReducer.hpp    mathicgb/F4MatrixReducer.cpp
  mathicgb/CFile.hpp              mathicgb/CFile.cpp
  mathicgb/LogDomain.hpp          mathicgb/LogDomain.cpp
  mathicgb/LogDomainSet.hpp       mathicgb/LogDomainSet.cpp
  mathicgb/F4MatrixBuilder2.hpp   mathicgb/F4MatrixBuilder2.cpp
  mathicgb/F4ProtoMatrix.hpp      mathicgb/F4ProtoMatrix.cpp
  mathicgb/F4MatrixProjection.hpp mathicgb/F4MatrixProjection.cpp
  mathicgb/io-util.hpp            mathicgb/io-util.cpp
  mathicgb/Scanner.hpp            mathicgb/Scanner.cpp
  mathicgb/stdinc.h
  )

target_compile_options(mathicgb PUBLIC
  $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
  )

target_link_libraries(mathicgb
  memtailor mathic Threads::Threads
  $<$<BOOL:${with_tbb}>:TBB::tbb>
  )

target_include_directories(mathicgb PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include>
  )

include(CTest)
if(BUILD_TESTING)
  add_executable(mathicgb-unit-tests
    test/F4MatrixBuilder.cpp
    test/F4MatrixReducer.cpp
    test/MathicIO.cpp
    test/MonoMonoid.cpp
    test/PrimeField.cpp
    test/QuadMatrixBuilder.cpp
    test/Range.cpp
    test/Scanner.cpp
    test/SparseMatrix.cpp
    test/gb-test.cpp
    test/ideals.hpp test/ideals.cpp
    test/mathicgb.cpp
    test/poly-test.cpp
    test/testMain.cpp
    )

  ################################
  # add gtest testing ############
  ################################
  if(NOT GTEST_FOUND)
    find_package(GTest)
  endif()
  include(GoogleTest)
  gtest_discover_tests(mathicgb-unit-tests TEST_PREFIX unit-tests:)

  if(GTEST_FOUND)
    target_link_libraries(mathicgb-unit-tests mathicgb GTest::GTest GTest::Main)
  else()
    include(FetchContent)
    FetchContent_Declare(googletest
      GIT_REPOSITORY https://github.com/google/googletest.git
      GIT_TAG        release-1.11.0
      )
    FetchContent_MakeAvailable(googletest)

    target_link_libraries(mathicgb-unit-tests mathicgb gtest)
    target_include_directories(mathicgb-unit-tests PRIVATE
      ${googletest_SOURCE_DIR}/googletest/include
      ${googletest_SOURCE_DIR}/googletest/src
      ${googletest_SOURCE_DIR}/googletest
      )
  endif()
endif()

=== debian/changelog ===
mathicgb (1.0~git20240206-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:05:18 +0000

mathicgb (1.0~git20240206-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062858

 -- Graham Inggs <ginggs@debian.org>  Thu, 29 Feb 2024 12:17:42 +0000

mathicgb (1.0~git20240206-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/copyright
    - Update my copyright years.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 05 Feb 2024 22:42:33 -0500

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: mathicgb
 Priority: optional
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                libgtest-dev <!nocheck>,
                libmathic-dev,
                libmemtailor-dev,
                libtbb-dev [linux-any],
                pkg-config
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git
@@ -32,7 +33,7 @@
 Package: libmathicgb-dev
 Section: libdevel
 Architecture: any
-Depends: libmathicgb0 (= ${binary:Version}), ${misc:Depends}
+Depends: libmathicgb0t64 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: Compute Groebner bases (developer tools)
  Mathicgb is a program for computing Groebner basis and signature Groebner
@@ -44,7 +45,10 @@
  .
  This package contains the developer tools.
 
-Package: libmathicgb0
+Package: libmathicgb0t64
+Provides: ${t64:Provides}
+Replaces: libmathicgb0
+Breaks: libmathicgb0 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WITH_GTEST := $(if $(filter nocheck, $(DEB_BUILD_OPTIONS)), \
	--without-gtest, GTEST_PATH=/usr/src/gtest)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(WITH_GTEST) --enable-shared

## mathicgb 1.0~git20250513

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,6 @@
   -DPACKAGE_BUGREPORT=""
   -DPACKAGE_URL=""
   -DPACKAGE="${PROJECT_NAME}"
-  $<$<NOT:$<BOOL:${with_tbb}>>:-DMATHICGB_NO_TBB>
   -Wall -Wextra -Wno-unused-parameter -Wno-unused-value -Wno-unused-variable -Wno-sign-compare
   )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -109,7 +109,7 @@
     include(FetchContent)
     FetchContent_Declare(googletest
       GIT_REPOSITORY https://github.com/google/googletest.git
-      GIT_TAG        release-1.11.0
+      GIT_TAG        v1.16.0
       )
     FetchContent_MakeAvailable(googletest)

=== debian/changelog ===
mathicgb (1.0~git20250513-1) unstable; urgency=medium

  * New upstream release (git snapshot).
  * debian/control
    - Bump Standards-Version to 4.7.2
    - Replace obsolete pkg-config with pkgconf in Build-Depends.
  * debian/copyright
    - Update my copyright years.
  * debian/gbp.conf
    - Set pristine-tar to true.
  * debian/libmathicgb0t64.lintian-overrides
    - Remove file; its only override is no longer used (lintian recognizes
      the t64 suffix).
  * debian/patches/libatomic.patch
    - Refresh for new release.
  * debian/rules
    - Don't set GTEST_PATH any more; no longer used.
  * debian/tests/unittest
    - Link against googletest instead of compiling it.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 26 Aug 2025 12:14:35 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: mathicgb
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                libgtest-dev <!nocheck>,
                libmathic-dev,
                libmemtailor-dev,
                libtbb-dev [linux-any],
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.2
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WITH_GTEST := $(if $(filter nocheck, $(DEB_BUILD_OPTIONS)), --without-gtest, )

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(WITH_GTEST) --enable-shared

=== debian/tests/control ===
Tests: unittest
Depends: build-essential,
         libgtest-dev,
         libmathic-dev,
         libmathicgb-dev,
         libmemtailor-dev,
         libtbb-dev,
         pkg-config
Restrictions: allow-stderr

## mathicgb 1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-project(mathicgb VERSION 1.0 LANGUAGES CXX)
+project(mathicgb VERSION 1.1 LANGUAGES CXX)
 
 option(enable_mgb "Build mgb" ON)
 option(with_tbb "use TBB for multithreading" auto)

=== debian/changelog ===
mathicgb (1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Remove redundant Rules-Requires-Root field.
  * debian/mathicgb.examples
    - Remove file; example files are not included in distribution tarball.
  * debian/watch
    - Update to use tarball on GitHub releases page.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 13 Dec 2025 18:11:14 -0500

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,6 @@
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git
 Vcs-Browser: https://salsa.debian.org/math-team/mathicgb
-Rules-Requires-Root: no
 
 Package: mathicgb
 Architecture: any

=== debian/watch ===
version=4
opts=searchmode=plain \
https://api.github.com/repos/Macaulay2/mathicgb/releases \
https://github.com/Macaulay2/mathicgb/releases/download/v.*/mathicgb-@ANY_VERSION@@ARCHIVE_EXT@

## mathicgb 1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-project(mathicgb VERSION 1.1 LANGUAGES CXX)
+project(mathicgb VERSION 1.2 LANGUAGES CXX)
 
 option(enable_mgb "Build mgb" ON)
 option(with_tbb "use TBB for multithreading" auto)
@@ -65,6 +65,7 @@
     src/cli/MatrixAction.hpp   src/cli/MatrixAction.cpp
     src/cli/SigGBAction.hpp    src/cli/SigGBAction.cpp
     src/cli/HelpAction.hpp     src/cli/HelpAction.cpp
+    src/cli/VersionAction.hpp  src/cli/VersionAction.cpp
     )
   target_link_libraries(mgb mathicgb)
   install(TARGETS mgb RUNTIME DESTINATION bin)

=== debian/changelog ===
mathicgb (1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Drop Priority field; "optional" is now the default.
    - Bump Standards-Version to 4.7.3.
  * debian/copyright
    - Update my copyright years.
  * debian/watch
    - Use a less greedy regex for the download URL.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 04 Feb 2026 06:51:19 -0500

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: mathicgb
-Priority: optional
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Doug Torrance <dtorrance@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
@@ -8,7 +7,7 @@
                libmemtailor-dev,
                libtbb-dev [linux-any],
                pkgconf
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: math
 Homepage: https://github.com/Macaulay2/mathicgb
 Vcs-Git: https://salsa.debian.org/math-team/mathicgb.git

=== debian/watch ===
version=4
opts=searchmode=plain \
https://api.github.com/repos/Macaulay2/mathicgb/releases \
[^"]*/mathicgb-@ANY_VERSION@@ARCHIVE_EXT@
